
package rice;

/**
 * Asynchronously executes a processing function, and returns the result.  
 * Just like Runnable, but has a return value;
 *
 * @version $Id: Executable.java 2302 2005-03-11 00:58:26Z jeffh $
 *
 * @author Alan Mislove
 */
public interface Executable {

  /**
   * Executes the potentially expensive task and returns the result.
   *
   * @param result The result of the command.
   */
  public Object execute();

}
