
package rice.pastry.socket.messaging;

import java.io.*;

import rice.pastry.*;
import rice.pastry.leafset.*;
import rice.pastry.socket.*;

/**
* A response message to a RoutesRequestMessage, containing the remote
 * node's routes.
 *
 * @version $Id: RoutesResponseMessage.java 2302 2005-03-11 00:58:26Z jeffh $
 *
 * @author Alan Mislove
 */
public class RoutesResponseMessage extends SocketMessage {
  
  private SourceRoute[] routes;
  
  /**
  * Constructor
   *
   * @param leafset The leafset of the receiver of the RoutesRequestMessage.
   */
  public RoutesResponseMessage(SourceRoute[] routes) {
    this.routes = routes;
  }
  
  /**
    * Returns the leafset of the receiver.
   *
   * @return The LeafSet of the receiver node.
   */
  public SourceRoute[] getRoutes() {
    return routes;
  }
}
